.global _ZN2clC1Ec3st2

# record di attivazione:
#
#           s2            -32
#                         -24
#   i       |         c   -16
#          this           -8
#         old %rbp        0  <- %rbp
#          %rip

_ZN2clC1Ec3st2:
# prologo
	pushq %rbp
	movq %rsp, %rbp
	subq $32, %rsp

# copia parametri
	movq %rdi, -8(%rbp)	# this
	movb %sil, -16(%rbp)	# c
	movq %rdx, -32(%rbp)	# s2 (parte meno significativa)
	movq %rcx, -24(%rbp)	# s2 (parte piu' significativa)
	
# ciclo for 
	# int i = 0
	movl $0, -12(%rbp) 	# i si trova a -16+4 rispetto a %rbp
	
for:	# i < 4
	cmpl $4, -12(%rbp)
	jge finefor
	# corpo
	
	# s.vc[i] = c
	movq -8(%rbp), %rdi	# this (era gia' in %rdi, ricopiamo
				# per sicurezza)
	movslq -12(%rbp), %rcx	# i, con estensione del segno
				# (i cambia ad ogni ciclo, dobbiamo
				#  ricopiare ogni volta)
	movb -16(%rbp), %al	# c -> %al
	movb %al, (%rdi, %rcx)  # %al -> s.vc[i]
	# v[i] = s2.vd[i] + s.vc[i]
	# prima calcoliamo l'espressione s2.vd[i] + s.vc[i]
	# s.vc[i] e' un char, deve essere convertito a intero
	movsbl (%rdi, %rcx), %eax	# s.vc[i] -> %eax
	# ora sommiamo s2.vd[i]
	addl -32(%rbp, %rcx, 4), %eax
	# quindi scriviamo il risultato in v[i]
	# (il risultato va convertito da int a long)
	movslq %eax, %rax # N.B.: movs esiste solo con dest. registro
	movq %rax, 8(%rdi, %rcx, 8)

	# i++
	incl -12(%rbp)
	jmp for
finefor:
	movq -8(%rbp), %rax
	leave
	ret

.global _ZN2cl5elab1ER3st1R3st2

# record di attivazione
#                   i      -72
#       cla                -64
#                          -56
#                          -48
#                          -40
#			   -32
#        s2                -24
#        s1                -16
#        this              -8
#       old %rbp            0  <- %rbp
#        %rip
_ZN2cl5elab1ER3st1R3st2:
# prologo
	pushq %rbp
	movq %rsp, %rbp
	subq $72, %rsp

# copia parametri
	movq %rdi, -8(%rbp)
	movq %rsi, -16(%rbp)
	movq %rdx, -24(%rbp)

# cl cla('f', s2)
	leaq -64(%rbp), %rdi 	# &cla
	movb $'f', %sil
	# copiamo s2 in %rdx, %rcx
	movq -24(%rbp), %r8
	movq (%r8), %rdx
	movq 8(%r8), %rcx
	call _ZN2clC1Ec3st2
# ciclo for
	# i = 0
	movl $0, -72(%rbp)
for2:	# i < 4
	cmpl $4, -72(%rbp)
	jge finefor2
	#corpo
	
	# primo if
	# s.vc[i] < s1.vc[i]
	movq -8(%rbp), %rdi	# preleviamo this
	movslq -72(%rbp), %rcx	# preleviamo i
	movb (%rdi, %rcx), %al	# s.vc[i] -> %al
	movq -16(%rbp), %r8	# preleviamo s1
	cmpb %al, (%r8, %rcx)	# confronto con s1.vc[i]
	jle fineif
	# corpo del primo if
	# s.vc[i] = cla.s.vc[i]
	movb -64(%rbp, %rcx), %al # cla.s.vc[i] -> %al
	movb %al, (%rdi, %rcx)	  # %al -> s.vc[i]
fineif:
	# secondo if
	# v[i] < cla.v[i]
	movq 8(%rdi, %rcx, 8), %rax 	# s.v[i] -> %rax
	cmpq %rax, -56(%rbp, %rcx, 8)	# confronto con cla.v[i]
	jle fineif2
	# corpo del secondo if
	# v[i] += cla.v[i]
	movq -56(%rbp, %rcx, 8), %rax	# cla.v[i] -> %rax
	addq %rax, 8(%rdi, %rcx, 8)	# v[i] += %rax
fineif2:
	# i++
	incl -72(%rbp)
	jmp for2
finefor2:
	leave
	ret
